<?php
/**
*	@author Matthias Drobny
*	@version 1.0
*	@date 2008-11-09
* 	@copyright Copyright (C) 2008 Matthias Drobny. All rights reserved.
* 	@license GNU/GPL
*	This Joomla 1.5 plugin replaces (backend-defined) keywords or html-fragments by other (backend-defined) code.
*	The replacement will be only inside the body tag to reduce inconsistent code.
*	At the moment the backend handles only one keyword and therefore only one replacement.
*	To increase this values slight modifications are necessary.
*		1. replaceBodyKeywords.php: set MAX_REPLACE_CONTENTKEYWORDS to your desired value
*		2. replaceBodyKeywords.xml: 
*			2.1 add more param lines
*			2.2 copy keyword_1 (keyword_[x]) and replacement_1 (replacement_[x]) (and spacer) and increment [x]
*/

// Check to ensure this file is included in Joomla!
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );
define("MAX_REPLACE_CONTENTKEYWORDS", 1);


/**
 * @author MDY
 * @version 1.1
 * Replaces backend defined keywords by backend defined replacement strings.
 * Currently no dynamic keywording. Amout is fixed to constant MAX_REPLACE_CONTENTKEYWORDS
 *
 * @uses MAX_REPLACE_CONTENTKEYWORDS
 * @package		Joomla
 * @subpackage	System
 * @since 		1.5
 */
class plgSystemReplaceBodyKeywords extends JPlugin
{
	function onAfterRender()
	{
		$app =& JFactory::getApplication();

		if($app->getName() != 'site') {
			return true;
		}
		$pluginParams = $this->params;
		$needles = array();
		$replace = array();
		$buffer = JResponse::getBody();

		
		$start = strpos($buffer, "<body");
		$end = strpos($buffer, "</body>")+7;
		$body = substr($buffer, $start, $end-$start);
		$prefix = substr($buffer, 0, $start);
		$suffix = substr($buffer, $end);

		for($i=1; $i<=MAX_REPLACE_CONTENTKEYWORDS; $i++) {
			if ($pluginParams->get( "keyword_".$i)) {
				$needles[] = $pluginParams->get( "keyword_".$i);
				$replace[] = $pluginParams->get( "replacement_".$i);
			}
		}

		$tmpBody = $body;
		$newBody = "";

		while(!empty($tmpBody)) {
			$startPos = strpos($tmpBody, "<");
			$endPos = strpos($tmpBody, ">")+1;
			if ($startPos>0) {
				if ($startPos<$endPos) {
					//	echter Text vorher, extrahieren
					$text = substr($tmpBody, 0, $startPos);
					$tmpBody = substr($tmpBody, $startPos);
					//	beliebige Funktion/Replace
					$newBody .= $this->replaceKeywords($text, $needles, $replace);
				} else {
					//	Abschlusstag vorher
					$newBody .= substr($tmpBody, 0, $endPos);
					$tmpBody = substr($tmpBody, $endPos);
				}
			} else {
				//	bis Abschlusstag abschneiden
				$newBody .= substr($tmpBody, 0, $endPos);
				$tmpBody = substr($tmpBody, $endPos);
			}
			$i++;
		}

		$buffer = $prefix.$newBody.$suffix;
		JResponse::setBody($buffer);

		return TRUE;
	}

	function replaceKeywords(&$string, &$keys, &$replaces) {
		$pluginParams = $this->params;
		if ($pluginParams->get("ignoreUpperLowerCase")==1) {
			$string = str_ireplace($keys, $replaces, $string);
		} else {
			$string = str_replace($keys, $replaces, $string);
		}
		return $string;
	}

	/**
	 * Constructor
	 *
	 * For php4 compatability we must not use the __constructor as a constructor for plugins
	 * because func_get_args ( void ) returns a copy of all passed arguments NOT references.
	 * This causes problems with cross-referencing necessary for the observer design pattern.
	 *
	 * @param object $subject The object to observe
	 * @param object $params  The object that holds the plugin parameters
	 * @since 1.5
	 */
	function plgSystemReplaceBodyKeywords( &$subject, $params )
	{
		parent::__construct( $subject, $params );
	}

}